#!/usr/bin/env bash

SCRIPT_DIR=$( cd -- "$( dirname -- "${BASH_SOURCE[0]}" )" &> /dev/null && pwd )
SOURCE_DIR=$SCRIPT_DIR/src

g++ $SOURCE_DIR/main.cpp \
       $SOURCE_DIR/base/core/base_types/Error.cpp \
       $SOURCE_DIR/base/core/base_types/Index.cpp \
       $SOURCE_DIR/base/core/data_structures/String.cpp \
       $SOURCE_DIR/base/core/file_utilities/FileSystemPath.cpp \
       $SOURCE_DIR/base/core/file_utilities/File.cpp \
       $SOURCE_DIR/base/core/file_utilities/Directory.cpp \
       $SOURCE_DIR/base/core/encoding/CharUtils.cpp \
       -o builder -g -fno-exceptions -fno-rtti \
        -I$SOURCE_DIR/base/core/data_structures \
        -I$SOURCE_DIR/base/core/base_types \
        -I$SOURCE_DIR/base/core/memory \
        -I$SOURCE_DIR/base/core/loggers \
        -I$SOURCE_DIR/base/core/encoding \
        -I$SOURCE_DIR/base/core/file_utilities
