#pragma once

#include "String.h"
#include "Result.h"

class FileSystemPath
{
public:
    FileSystemPath() = default;

    FileSystemPath(const String& path);

    const String& as_string() const;

    static FileSystemPath current_dir();

    String extension() const;

    bool exists() const;

    Result<bool> is_empty() const;

    Result<size_t> get_size() const;

    FileSystemPath join(const String& entry) const;

    bool is_regular_file() const;

    bool is_directory() const;

    bool is_absolute() const;

    FileSystemPath parent_path() const;

private:
    String m_delimiter{"/"};
    String m_path;
};