#pragma once

#define MLOG_ALL(msg, level) {String mt_logstream;\
    mt_logstream << msg; \
    FileLogger::GetInstance().LogLine(level, mt_logstream, __FILE__, __FUNCTION__, __LINE__);};

#define MLOG_INFO(msg) MLOG_ALL(msg, "Info");
#define MLOG_ERROR(msg) MLOG_ALL(msg, "Error");

#include "Pointer.h"
#include "String.h"

class FileLogger
{
    FileLogger();

public:
    static FileLogger& GetInstance();

    FileLogger(FileLogger const&) = delete;
    void operator=(FileLogger const&)  = delete;

    ~FileLogger();

    void disable();

    void SetWorkDirectory(const String& workDir);

    void SetFileName(const String& fileName);

    void Open();

    void Close();

    void LogLine(const String& line);

    void LogLine(const String& logType, const String& line, const String& fileName = "", const String& functionName = "", int lineNumber=-1);
private:
    bool mDisabled{false};
    String mWorkDirectory;
    String mFileName;
};