#pragma once

#include "PngInfo.h"

#include <vector>
#include <cstdint>

class PngHeader
{
public:
    DWord getLength() const;

    DWord getCrc();

    const VecBytes& getData() const;

    DWord getWidth() const;

    DWord getHeight() const;

    Byte getBitDepth() const;

    const PngInfo& getPngInfo() const;

    Byte getHighBitCheck() const;

    void getSignature(VecBytes& sig) const;

    std::string getFileName() const;

    const std::string& getChunkName() const;

    void setPngInfo(const PngInfo& info);

    void setImageData(DWord width, DWord height, Byte bitDepth);

    std::string toString() const;

    void updateData();

private:
    DWord mWidth{0};
    DWord mHeight{0};
    Byte mBitDepth{0};
    PngInfo mPngInfo;
    std::string mName{"IHDR"};

    DWord mCachedCrc{0};

    VecBytes mData;
};
